----------------------------------------------------------------------------------
-- Company:    Digilent inc
-- Engineer:   Kovacs Laszlo - Attila
-- 
-- Create Date:    19:32:30 03/29/2007 
-- Design Name: 
-- Module Name:    PModOC1 - Behavioral 
-- Project Name: 
-- Target Device:  X-Board, PModOC1
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity PModOC1 is
    Port ( 
      Clk      : in  std_logic;

      DataIn   : in  std_logic_vector(7 downto 0);
      DataOut  : out std_logic_vector(7 downto 0);
      Read     : in  std_logic;
      Write    : in  std_logic;
      DataRdy  : out std_logic;

      P1       : out std_logic;
      P2       : out std_logic;
      P3       : out std_logic;
      P4       : out std_logic);
end PModOC1;

architecture Behavioral of PModOC1 is

signal data : std_logic_vector(3 downto 0) := x"0";

begin
   
   -- pin mapping
   P1 <= data(0);
   P2 <= data(1);
   P3 <= data(2);
   P4 <= data(3);
   
   
   DataOut <= x"0" & data;   
   
   process(Clk)
   begin
      if rising_edge(Clk) then
         -- handshake EPP module
         if Read = '1' or Write = '1' then
            DataRdy <= '1';
         else
            DataRdy <= '0';
         end if;

         -- set Write Request flag
         if Write = '1' then
            data <= DataIn(3 downto 0);
         end if;
      end if;         
   end process;
   
  
   
end Behavioral;
